#include <sys/wait.h>
#include <sys/types.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>

/*
 * FUNCION QUE CIERRA EL PROGRAMA
 */
void cierre()
{
  printf("\n PADRE: Me llego un SIGINT y voy a cerrarme en 7 seg.\n\n");fflush(stdout);
  sleep(7);  
  exit(0);
}

/*
 * FUNCION PRINCIPAL MAIN
 */
int main(int argc, char *argv[])
{
    pid_t pidH1, pidH2,pidH21;	/* PID's de procesos involucrados */
    int DA[2];					/* DESCRIPTORES PIPE A - Comunicacion entre PADRE e HIJO1 */
    int DB[2];					/* DESCRIPTORES PIPE B - Comunicacion entre PADRE e HIJO2 */
    int DC[2];					/* DESCRIPTORES PIPE C - Comunicacion entre HIJO2 e HIJO21 */
    
    int /*i,*/ status;
    char c;				/* Permite al PADRE capturar informacion del ping (caracter x caracter) 
                                           enviada x HIJO1 */
    char c2;				/* Permite al HIJO21 capturar informacion de la salida estandar del HIJO2 
                                           para evitar mostrar en pantalla lo que despliega MatLab */
    
    FILE * sd1;				/* Descriptor que permite lectura desde la PIPE A para evitar uso 'read' */
    FILE * sd2;				/* Descriptor que permite escritura a la PIPE A para evitar uso 'write' */
    FILE * sd3;				/* Descriptor que permite lectura desde la PIPE C para evitar uso 'read'  */
    
    
    //Strings para manejo de argumentos de la funcion gping
    char str1[300];
    //char str2[200];
    char str3[400];
    char str4[400];
    char xi[5];
    char yi[5];
    char temp[2];
    int f1,f2,f3,count;

    temp[0]='\0';
    xi[0]='\0';
    yi[0]='\0';
    str1[0]=' ';

    signal(SIGINT,cierre);   
    
    printf("\n ========================================== \n");
    printf("  ESPERE MIENTRAS SE DESPLIEGA LA PANTALLA");
    printf("\n ========================================== \n\n");
    
    
    /*
     * CREACION DE PIPE A
     */
    if (pipe(DA) < 0) {
        perror("error creacion pipe A");
        exit(1);
    }
    
    /*
     * CREACION DE PIPE B
     */
    if (pipe(DB) < 0) {
        perror("error creacion pipe B");
        exit(1);
    }

    /*
     * CREACION HIJO 1
     */
    if ((pidH1 = fork()) < 0) {
        perror("error fork de Hijo 1");
        exit(1);
    }
    
    /*
     * CREACION HIJO 2 - Solo lo ejecuta el Padre.
     */
     
    if (pidH1 > 0)	//Indica que es el proceso PADRE quien ejecutara el codigo interior Y no el HIJO1
    {
      if ((pidH2 = fork()) < 0) {
        perror("error fork de Hijo 2");
        exit(1);
      }
      
    } 
        
    /*
     * El HIJO1 ejecuta el "ping"
     */
    if (pidH1 == 0) {
        /*
         * Se copia la salida de escritura de la PIPE A a la salida estandar
         */
        
        
        close(DA[0]);
        
        close(DB[0]);	//Se cierran descriptores hacia la PIPE B
        close(DB[1]);
        
        if(argc==1)
        {         
          printf("\n HIJO1: ERROR SINTAXIS GPING - Falta host \n\n");fflush(stdout);
          _exit(127);
        }
        
        if(argc==2)
        {
          dup2(DA[1], 1); //Causa que la salida estandar del HIJO1 se refiera al descriptor de escritura de la PIPE A
          execl("/bin/ping", "ping", argv[1], NULL);
          perror("exec: error al ejecutar ping");
          _exit(127);
        }
        
        printf("\n HIJO1: Error el ejecutar GPING - Voy a terminar\n");fflush(stdout);
        _exit(127);
    }
    
    /*
     * El HIJO2 ejecuta el "MatLab"
     */
    
    if(pidH2 == 0) {
  
        /*
         * Se copia la entrada de lectura de la PIPE B a la entrada estandar del HIJO2
         */
        dup2(DB[0],0);	//Causa que la entrada estandar del HIJO2 se refiera al descriptor de lectura de la PIPE B
        close(DB[1]);
        
        close(DA[0]);	//Se cierran descriptores hacia la PIPE A
        close(DA[1]);
        
        /*
         * CREACION DE PIPE C - El HIJO2 es quien la crea
         */
        if (pipe(DC) < 0) {
          perror("error creacion pipe C");
          exit(1);
        }
        
        /*
         * CREACION HIJO 21 - Este hijo es hijo de HIJO2
         */
        if ((pidH21 = fork()) < 0) {
           perror("error fork de Hijo 1");
           exit(1);
        }
        
        /*
         * HIJO 21 captura la salida estandar del HIJO2 (Info Consola MatLab)
         */
        if(pidH21==0)
        {
          close(DC[1]);
          close(DA[0]); close(DA[1]);
          close(DB[0]); close(DB[1]);
          
          sd3 = fdopen(DC[0],"r");	// sd3 => DC[0] : Extremo lectura PIPE C
          
          while( (c2=fgetc(sd3))!=EOF ){ /*printf("*"); putchar(c2);*/ }
          
          _exit(129);     
        }
        
        dup2(DC[1],1);
        close(DC[0]);	//Se cierra extremo lectura PIPE C para enviar datos a HIJO21
        
        /*
         * El HIJO2 ejecuta MatLab despues de haber creado al HIJO21
         */
        execlp("matlab", "matlab","-nodesktop","-nosplash", 0);
        perror("error en exec de MatLab");
        printf("\n Hijo 2: Voy a cerrarme \n");
        _exit(128);
    }

    /*
     * El PADRE leera de la PIPE A por lo tanto cierra extremo escritor
     * EL PADRE escribe en la PIPE B por lo tanto cierra extremo lector
     */
    close(DA[1]);
    close(DB[0]);

    /*
     * PADRE lee de la PIPE A
     * PADRE escribe en la PIPE B
     */     
    sd1 = fdopen(DA[0],"r");	// sd1 => DA[0] : Extremo lectura PIPE A
    sd2 = fdopen(DB[1],"w");	// sd2 => DB[1] : Extremo escritura PIPE B
    

    
    fprintf(sd2,"x=zeros(1);\n");fflush(sd2); // Se "inicializa" una variable en el MatLab que representa el eje X
    fprintf(sd2,"y=zeros(1);\n");fflush(sd2); // Se "inicializa" una variable en el MatLab que representa el eje Y
    
    
    
    
    /*
     * Filtro de datos generales del ping y envio de de estos al HIJO2 para su ejecucion en MatLab
     * Tarea realizada por el PADRE
     */
    count=0; f1=1; f2=0; f3=0;	//Variables ocupadas para manejar ciclo while que filtra datos del ping
    
    while( (c=fgetc(sd1))!=EOF )
    {
      if( c==61 && f1==1 )	//Busca un signo '=' en los caracteres que se van leyendo
      {
        count++;		//Incrementa contador de iguales pq encontro un igual
        f1=0; f2=1; f3=1; 	
        continue;
      }
      
      if( f2==1 && (count==1 || count==3) && c!=32 ) 	//Se mete hasta encontrar un espacio
      {
        if(count==1)
        {
          temp[0]=c;
          temp[1]='\0';
          strcat(xi,temp);	//Concatena entre dos strings
        }
          
        if(count==3)
        {
          temp[0]=c;
          temp[1]='\0';
          strcat(yi,temp);
        }
        
        continue;      
      }
      
      if( f3==1 && c==32 )	//Se mete pq encontro un espacio
      {
        
        if(count==1)
        {
          //printf("\n x=%s",xi);fflush(stdout);
          sprintf(str3,"x=cat(2,x,%s);\n",xi);	//Se guarda en str3 el comando a ejecutar en MatLab
          fprintf(sd2,str3);fflush(sd2);	//Se envia el comando a ejecutar en MatLab
        }
      
        if(count==3) 
        {
          //printf("\n y=%s",yi);fflush(stdout);
          sprintf(str4,"y=cat(2,y,%s);\n",yi);
          fprintf(sd2,str4);fflush(sd2);
          fprintf(sd2,"subplot(2,1,1);\n");fflush(sd2);
          fprintf(sd2,"plot(x(1:length(x)),y(1:length(y)));\n");fflush(sd2);
          fprintf(sd2,"xlabel('Numero del paquete enviado');ylabel('Tiempo de respuesta');\n");fflush(sd2);
          
          fprintf(sd2,"Y=fft(y,512);Pyy=Y.*conj(Y)/512;\n");fflush(sd2);
          fprintf(sd2,"f=1000*(0:256)/512;\n");fflush(sd2);
          fprintf(sd2,"subplot(2,1,2);\n");fflush(sd2);
          fprintf(sd2,"plot(f,Pyy(1:257));\n");fflush(sd2);
          fprintf(sd2,"xlabel('Frecuencia');ylabel('Magnitud');\n");fflush(sd2);
          
          count=0;				//Indica que termino la linea actual y que el proximo 
                                                //igual sera el primero
        }
        
        f1=1; f2=0; f3=0;
        
        temp[0]='\0';	//Se "vacian" los strings temporales usados para formar los comandos finales
        xi[0]='\0';
        yi[0]='\0';
        
      }
    }
    
    /************ FIN DEL FILTRO DEL PADRE *************/
    
    
    fclose(sd1);
    //fclose(sd2);

    /*
     * Close the pipe and wait for the child
     * to exit.
     */
    close(DA[0]);
        
    waitpid(pidH1, &status, 0);

    /*
     * Exit with a status of 0, indicating that
     * everything went fine.
     */
    exit(0);
}
